/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.91 Revision 1.132
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.91 2011/07/08 11:35:01 ssuominen Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.132 2012/06/07 15:36:49 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
44 ;;
45esac
46
47IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 48if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
22 IUSE="+exceptions" 49 IUSE+=" +exceptions"
23else
24 MY_P=qt-x11-opensource-src-${MY_PV}
25fi 50fi
51if version_is_at_least 4.8; then
52 IUSE+=" c++0x qpa"
53fi
26 54
27HOMEPAGE="http://qt.nokia.com/" 55DEPEND="virtual/pkgconfig"
28SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 56if [[ ${QT4_BUILD_TYPE} == live ]]; then
29 57 DEPEND+=" dev-lang/perl"
30LICENSE="|| ( LGPL-2.1 GPL-3 )" 58fi
31IUSE+=" debug pch aqua"
32 59
33RDEPEND=" 60RDEPEND="
34 !<x11-libs/qt-assistant-${PV} 61 !<x11-libs/qt-assistant-${PV}:4
35 !>x11-libs/qt-assistant-${PV}-r9999 62 !>x11-libs/qt-assistant-${PV}-r9999:4
63 !<x11-libs/qt-bearer-${PV}:4
64 !>x11-libs/qt-bearer-${PV}-r9999:4
36 !<x11-libs/qt-core-${PV} 65 !<x11-libs/qt-core-${PV}:4
37 !>x11-libs/qt-core-${PV}-r9999 66 !>x11-libs/qt-core-${PV}-r9999:4
38 !<x11-libs/qt-dbus-${PV} 67 !<x11-libs/qt-dbus-${PV}:4
39 !>x11-libs/qt-dbus-${PV}-r9999 68 !>x11-libs/qt-dbus-${PV}-r9999:4
69 !<x11-libs/qt-declarative-${PV}:4
70 !>x11-libs/qt-declarative-${PV}-r9999:4
40 !<x11-libs/qt-demo-${PV} 71 !<x11-libs/qt-demo-${PV}:4
41 !>x11-libs/qt-demo-${PV}-r9999 72 !>x11-libs/qt-demo-${PV}-r9999:4
42 !<x11-libs/qt-gui-${PV} 73 !<x11-libs/qt-gui-${PV}:4
43 !>x11-libs/qt-gui-${PV}-r9999 74 !>x11-libs/qt-gui-${PV}-r9999:4
44 !<x11-libs/qt-multimedia-${PV} 75 !<x11-libs/qt-multimedia-${PV}:4
45 !>x11-libs/qt-multimedia-${PV}-r9999 76 !>x11-libs/qt-multimedia-${PV}-r9999:4
46 !<x11-libs/qt-opengl-${PV} 77 !<x11-libs/qt-opengl-${PV}:4
47 !>x11-libs/qt-opengl-${PV}-r9999 78 !>x11-libs/qt-opengl-${PV}-r9999:4
79 !<x11-libs/qt-openvg-${PV}:4
80 !>x11-libs/qt-openvg-${PV}-r9999:4
48 !<x11-libs/qt-phonon-${PV} 81 !<x11-libs/qt-phonon-${PV}:4
49 !>x11-libs/qt-phonon-${PV}-r9999 82 !>x11-libs/qt-phonon-${PV}-r9999:4
50 !<x11-libs/qt-qt3support-${PV} 83 !<x11-libs/qt-qt3support-${PV}:4
51 !>x11-libs/qt-qt3support-${PV}-r9999 84 !>x11-libs/qt-qt3support-${PV}-r9999:4
52 !<x11-libs/qt-script-${PV} 85 !<x11-libs/qt-script-${PV}:4
53 !>x11-libs/qt-script-${PV}-r9999 86 !>x11-libs/qt-script-${PV}-r9999:4
54 !<x11-libs/qt-sql-${PV} 87 !<x11-libs/qt-sql-${PV}:4
55 !>x11-libs/qt-sql-${PV}-r9999 88 !>x11-libs/qt-sql-${PV}-r9999:4
56 !<x11-libs/qt-svg-${PV} 89 !<x11-libs/qt-svg-${PV}:4
57 !>x11-libs/qt-svg-${PV}-r9999 90 !>x11-libs/qt-svg-${PV}-r9999:4
58 !<x11-libs/qt-test-${PV} 91 !<x11-libs/qt-test-${PV}:4
59 !>x11-libs/qt-test-${PV}-r9999 92 !>x11-libs/qt-test-${PV}-r9999:4
60 !<x11-libs/qt-webkit-${PV} 93 !<x11-libs/qt-webkit-${PV}:4
61 !>x11-libs/qt-webkit-${PV}-r9999 94 !>x11-libs/qt-webkit-${PV}-r9999:4
62 !<x11-libs/qt-xmlpatterns-${PV} 95 !<x11-libs/qt-xmlpatterns-${PV}:4
63 !>x11-libs/qt-xmlpatterns-${PV}-r9999 96 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
64" 97"
65 98
66S=${WORKDIR}/${MY_P} 99S=${WORKDIR}/${MY_P}
67 100
68# @FUNCTION: qt4-build_pkg_setup 101# @FUNCTION: qt4-build_pkg_setup
69# @DESCRIPTION: 102# @DESCRIPTION:
70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 103# Sets up PATH and LD_LIBRARY_PATH.
71qt4-build_pkg_setup() { 104qt4-build_pkg_setup() {
72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 105 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
73 106
74 # Protect users by not allowing downgrades between releases 107 # Protect users by not allowing downgrades between releases
75 # Downgrading revisions within the same release should be allowed 108 # Downgrading revisions within the same release should be allowed
76 if has_version '>'${CATEGORY}/${P}-r9999 ; then 109 if has_version ">${CATEGORY}/${P}-r9999:4"; then
77 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 110 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
111 eerror
78 eerror "Sanity check to keep you from breaking your system:" 112 eerror "Sanity check to keep you from breaking your system:"
79 eerror " Downgrading Qt is completely unsupported and will break your system!" 113 eerror " Downgrading Qt is completely unsupported and will break your system!"
114 eerror
80 die "aborting to save your system" 115 die "aborting to save your system"
81 else 116 else
82 ewarn "Downgrading Qt is completely unsupported and will break your system!" 117 ewarn "Downgrading Qt is completely unsupported and will break your system!"
83 fi 118 fi
84 fi 119 fi
85 120
86 if [[ "${PN}" == "qt-webkit" ]]; then 121 if [[ ${PN} == qt-webkit ]]; then
87 eshopts_push -s extglob 122 eshopts_push -s extglob
88 if is-flagq '-g?(gdb)?([1-9])'; then 123 if is-flagq '-g?(gdb)?([1-9])'; then
89 echo 124 echo
90 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)." 125 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
91 ewarn "You may experience really long compilation times and/or increased memory usage." 126 ewarn "You may experience really long compilation times and/or increased memory usage."
92 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug." 127 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
93 ewarn "For more info check out bug #307861" 128 ewarn "For more info check out bug #307861"
94 echo 129 echo
95 fi 130 fi
96 eshopts_pop 131 eshopts_pop
97 fi 132 fi
107 [[ ${CHOST} == *-apple-darwin* ]] && \ 142 [[ ${CHOST} == *-apple-darwin* ]] && \
108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 143 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}" 144 ${QT4_EXTRACT_DIRECTORIES}"
110 fi 145 fi
111 146
112 # Make sure ebuilds use the required EAPI
113 if [[ ${EAPI} != [23] ]]; then
114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
115 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
116 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
117 die "qt4-build eclass requires EAPI=2 or EAPI=3"
118 fi
119
120 if ! version_is_at_least 4.1 $(gcc-version); then 147 if ! version_is_at_least 4.1 $(gcc-version); then
121 ewarn "Using a GCC version lower than 4.1 is not supported!" 148 ewarn "Using a GCC version lower than 4.1 is not supported."
122 fi 149 fi
123} 150}
124 151
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 152# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
126# @DESCRIPTION: 153# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 154# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 155# code should be compiled. This is a space-separated list.
129 156
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 157# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION: 158# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt 159# Space-separated list including the directories that will be extracted from
133# tarball 160# Qt tarball.
134 161
135# @FUNCTION: qt4-build_src_unpack 162# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 163# @DESCRIPTION:
137# Unpacks the sources 164# Unpacks the sources.
138qt4-build_src_unpack() { 165qt4-build_src_unpack() {
139 setqtenv 166 setqtenv
140 local target targets= 167
168 case ${QT4_BUILD_TYPE} in
169 live)
170 git-2_src_unpack
171 ;;
172 release)
173 local tarball="${MY_P}.tar.gz" target= targets=
141 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 174 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
142 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 175 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
143 ${QT4_EXTRACT_DIRECTORIES}; do 176 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
177 do
144 targets+=" ${MY_P}/${target}" 178 targets+="${MY_P}/${target} "
145 done 179 done
146 180
181 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
147 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 182 tar -xzf "${DISTDIR}/${tarball}" ${targets}
148 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 183 eend $? || die "failed to unpack"
184 ;;
185 esac
149} 186}
150 187
151# @ECLASS-VARIABLE: PATCHES 188# @ECLASS-VARIABLE: PATCHES
189# @DEFAULT_UNSET
152# @DESCRIPTION: 190# @DESCRIPTION:
153# In case you have patches to apply, specify them in PATCHES variable. Make sure 191# PATCHES array variable containing all various patches to be applied.
154# to specify the full path. This variable is necessary for src_prepare phase. 192# This variable is expected to be defined in global scope of ebuild.
155# example: 193# Make sure to specify the full path. This variable is utilised in
156# PATCHES="${FILESDIR}"/mypatch.patch 194# src_unpack/src_prepare phase, based on EAPI.
157# ${FILESDIR}"/mypatch2.patch"
158# 195#
196# @CODE
197# PATCHES=( "${FILESDIR}/mypatch.patch"
198# "${FILESDIR}/patches_folder/" )
199# @CODE
159 200
160# @FUNCTION: qt4-build_src_prepare 201# @FUNCTION: qt4-build_src_prepare
161# @DESCRIPTION: 202# @DESCRIPTION:
162# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 203# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
163# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 204# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
164qt4-build_src_prepare() { 205qt4-build_src_prepare() {
165 setqtenv 206 setqtenv
166 cd "${S}" 207
167 208 if [[ ${QT4_BUILD_TYPE} == live ]]; then
168 # fix qt 4.7 regression that skips -fvisibility=hidden 209 QTDIR="." ./bin/syncqt || die "syncqt failed"
210 fi
211
169 if version_is_at_least "4.7.0_beta1"; then 212 if version_is_at_least 4.7; then
170 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
171 -i config.tests/unix/fvisibility.test ||
172 die "visibility fixing sed failed"
173 fi
174 # fix libx11 dependency on non X packages 213 # fix libX11 dependency on non X packages
175 if version_is_at_least "4.7.0_beta2"; then
176 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 214 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
177 has ${PN} ${NOLIBX11PKG} && qt_nolibx11 215 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
178 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup 216
217 qt_assistant_cleanup
179 fi 218 fi
180 219
181 if use aqua; then 220 if use aqua; then
182 # provide a proper macx-g++-64 221 # provide a proper macx-g++-64
183 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 222 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
184 223
185 sed -e '/^CONFIG/s:app_bundle::' \ 224 sed -e '/^CONFIG/s:app_bundle::' \
186 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 225 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
187 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 226 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
188 fi 227 fi
189 228
190 if [[ ${PN} != qt-core ]]; then 229 if [[ ${PN} != qt-core ]]; then
191 skip_qmake_build_patch 230 skip_qmake_build
192 skip_project_generation_patch 231 skip_project_generation
193 symlink_binaries_to_buildtree 232 symlink_binaries_to_buildtree
194 fi 233 fi
195 234
196 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 235 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
197 # qmake bus errors with -O2 but -O3 works 236 # qmake bus errors with -O2 or -O3 but -O1 works
237 # Bug 373061
198 replace-flags -O2 -O3 238 replace-flags -O[23] -O1
199 fi 239 fi
200 240
201 # Bug 178652 241 # Bug 178652
202 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 242 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
203 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 243 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
204 append-flags -fno-gcse 244 append-flags -fno-gcse
205 fi 245 fi
206 246
247 if use_if_iuse c++0x; then
248 echo
249 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
250 ewarn "this is an official standard, some of the reverse dependencies"
251 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
252 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
253 ewarn "disabled."
254 echo
255 append-flags -std=c++0x
256 fi
257
207 # Unsupported old gcc versions - hardened needs this :( 258 # Unsupported old gcc versions - hardened needs this :(
208 if [[ $(gcc-major-version) -lt 4 ]] ; then 259 if [[ $(gcc-major-version) -lt 4 ]]; then
209 ewarn "Appending -fno-stack-protector to CXXFLAGS" 260 ewarn "Appending -fno-stack-protector to CXXFLAGS"
210 append-cxxflags -fno-stack-protector 261 append-cxxflags -fno-stack-protector
211 # Bug 253127 262 # Bug 253127
212 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 263 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
213 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 264 -i mkspecs/common/g++.conf || die
214 fi 265 fi
215 266
216 # Bug 261632 267 # Bug 261632
217 if use ppc64; then 268 if use ppc64; then
218 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 269 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
219 append-flags -mminimal-toc 270 append-flags -mminimal-toc
220 fi 271 fi
221 272
222 # Bug 282984 && Bug 295530 273 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
223 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 274 sed -e "/^SYSTEM_VARIABLES=/i \
224 -i configure || die "sed qmake compilers failed" 275 CC='$(tc-getCC)'\n\
225 # bug 321335 276 CXX='$(tc-getCXX)'\n\
277 CFLAGS='${CFLAGS}'\n\
278 CXXFLAGS='${CXXFLAGS}'\n\
279 LDFLAGS='${LDFLAGS}'\n" \
280 -i configure \
281 || die "sed SYSTEM_VARIABLES failed"
282
283 # Respect CC, CXX, LINK and *FLAGS in config.tests
284 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
285 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
286 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
287 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
288 || die "sed config.tests failed"
289
226 if version_is_at_least 4.6; then 290 if ! version_is_at_least 4.8; then
227 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 291 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
228 xargs -0 \ 292 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
229 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
230 -i || die "sed test compilers failed"
231 fi 293 fi
232 294
233 # Bug 172219 295 # Bug 172219
234 sed -e "s:X11R6/::" \ 296 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
235 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
236 297
237 if [[ ${CHOST} == *-darwin* ]]; then 298 if [[ ${CHOST} == *-darwin* ]]; then
238 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 299 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
239 # crippled (by design) :/ 300 # crippled (by design) :/
301 local mac_gpp_conf=
302 if [[ -f mkspecs/common/mac-g++.conf ]]; then
303 # qt < 4.8 has mac-g++.conf
304 mac_gpp_conf="mkspecs/common/mac-g++.conf"
305 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
306 # qt >= 4.8 has g++-macx.conf
307 mac_gpp_conf="mkspecs/common/g++-macx.conf"
308 else
309 die "no known conf file for mac found"
310 fi
311 sed \
240 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 312 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
241 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 313 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
242 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 314 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
243 -e "s:-arch\s\w*::g" \ 315 -e "s:-arch\s\w*::g" \
244 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 316 -i ${mac_gpp_conf} \
317 || die "sed ${mac_gpp_conf} failed"
245 318
246 # Fix configure's -arch settings that appear in qmake/Makefile and also 319 # Fix configure's -arch settings that appear in qmake/Makefile and also
247 # fix arch handling (automagically duplicates our -arch arg and breaks 320 # fix arch handling (automagically duplicates our -arch arg and breaks
248 # pch). Additionally disable Xarch support. 321 # pch). Additionally disable Xarch support.
322 local mac_gcc_confs="${mac_gpp_conf}"
323 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
324 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
325 fi
249 sed \ 326 sed \
250 -e "s:-arch i386::" \ 327 -e "s:-arch i386::" \
251 -e "s:-arch ppc::" \ 328 -e "s:-arch ppc::" \
252 -e "s:-arch x86_64::" \ 329 -e "s:-arch x86_64::" \
253 -e "s:-arch ppc64::" \ 330 -e "s:-arch ppc64::" \
254 -e "s:-arch \$i::" \ 331 -e "s:-arch \$i::" \
255 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 332 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
256 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 333 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
257 -e "s:-Xarch_x86_64::g" \ 334 -e "s:-Xarch_x86_64::g" \
258 -e "s:-Xarch_ppc64::g" \ 335 -e "s:-Xarch_ppc64::g" \
259 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 336 -i configure ${mac_gcc_confs} \
337 || die "sed -arch/-Xarch failed"
260 338
261 # On Snow Leopard don't fall back to 10.5 deployment target. 339 # On Snow Leopard don't fall back to 10.5 deployment target.
262 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 340 if [[ ${CHOST} == *-apple-darwin10 ]]; then
263 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 341 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
264 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 342 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
265 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 343 -i configure ${mac_gpp_conf} \
344 || die "sed deployment target failed"
266 fi 345 fi
267 fi 346 fi
268 347
269 # this one is needed for all systems with a separate -liconv, apart from 348 # this one is needed for all systems with a separate -liconv, apart from
270 # Darwin, for which the sources already cater for -liconv 349 # Darwin, for which the sources already cater for -liconv
271 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 350 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
272 sed \ 351 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
273 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
274 -i config.tests/unix/iconv/iconv.pro \ 352 -i config.tests/unix/iconv/iconv.pro \
275 || die "sed on iconv.pro failed" 353 || die "sed iconv.pro failed"
276 fi 354 fi
277 355
278 # we need some patches for Solaris 356 # we need some patches for Solaris
279 sed -i \
280 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 357 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
281 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 358 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
282 # use GCC over SunStudio 359 # use GCC over SunStudio
283 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 360 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
284 # don't flirt with non-Prefix stuff, we're quite possessive 361 # do not flirt with non-Prefix stuff, we're quite possessive
285 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 362 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
286 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 363 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
287 # strip predefined CFLAGS from qmake ( bug #312689 )
288 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
289 364
290 base_src_prepare 365 base_src_prepare
291} 366}
292 367
293# @FUNCTION: qt4-build_src_configure 368# @FUNCTION: qt4-build_src_configure
294# @DESCRIPTION: 369# @DESCRIPTION:
295# Default configure phase 370# Default configure phase
296qt4-build_src_configure() { 371qt4-build_src_configure() {
297 setqtenv 372 setqtenv
298 myconf="$(standard_configure_options) ${myconf}" 373
374 local conf="
375 -prefix ${QTPREFIXDIR}
376 -bindir ${QTBINDIR}
377 -libdir ${QTLIBDIR}
378 -docdir ${QTDOCDIR}
379 -headerdir ${QTHEADERDIR}
380 -plugindir ${QTPLUGINDIR}
381 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
382 -datadir ${QTDATADIR}
383 -translationdir ${QTTRANSDIR}
384 -sysconfdir ${QTSYSCONFDIR}
385 -examplesdir ${QTEXAMPLESDIR}
386 -demosdir ${QTDEMOSDIR}
387 -opensource -confirm-license
388 -shared -fast -largefile -stl -verbose
389 -nomake examples -nomake demos"
390
391 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
392 # $(tc-arch). Therefore we convert it to supported values.
393 case "$(tc-arch)" in
394 amd64|x64-*) conf+=" -arch x86_64" ;;
395 ppc-macos) conf+=" -arch ppc" ;;
396 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
397 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
398 x86-macos) conf+=" -arch x86" ;;
399 x86|x86-*) conf+=" -arch i386" ;;
400 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
401 hppa|sh) conf+=" -arch generic" ;;
402 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
403 esac
404
405 conf+=" -platform $(qt_mkspecs_dir)"
406
407 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
408
409 # debug/release
410 if use debug; then
411 conf+=" -debug"
412 else
413 conf+=" -release"
414 fi
415 conf+=" -no-separate-debug-info"
416
417 # exceptions USE flag
418 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
419
420 # disable rpath on Qt >= 4.8 (bug 380415)
421 # but leave it enabled on prefix (bug 417169)
422 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
423
424 # precompiled headers don't work on hardened, where the flag is masked
425 conf+=" $(qt_use pch)"
426
427 # -reduce-relocations
428 # This flag seems to introduce major breakage to applications,
429 # mostly to be seen as a core dump with the message "QPixmap: Must
430 # construct a QApplication before a QPaintDevice" on Solaris.
431 # -- Daniel Vergien
432 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
299 433
300 # this one is needed for all systems with a separate -liconv, apart from 434 # this one is needed for all systems with a separate -liconv, apart from
301 # Darwin, for which the sources already cater for -liconv 435 # Darwin, for which the sources already cater for -liconv
302 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 436 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
303 myconf+=" -liconv" 437 conf+=" -liconv"
438 fi
304 439
305 if has glib ${IUSE//+} && use glib; then 440 if use_if_iuse glib; then
306 # use -I, -L and -l from configure
307 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 441 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
308 # avoid the -pthread argument 442 # avoid the -pthread argument
309 myconf+=" ${glibflags//-pthread}" 443 conf+=" ${glibflags//-pthread}"
310 unset glibflags 444 unset glibflags
311 fi 445 fi
312 446
447 if use_if_iuse qpa; then
448 echo
449 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
450 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
451 ewarn "disable it before reporting any bugs related to this useflag."
452 echo
453 conf+=" -qpa"
454 fi
455
313 if use aqua ; then 456 if use aqua; then
314 # On (snow) leopard use the new (frameworked) cocoa code. 457 # On (snow) leopard use the new (frameworked) cocoa code.
315 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 458 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
316 myconf+=" -cocoa -framework" 459 conf+=" -cocoa -framework"
460 # We need the source's headers, not the installed ones.
461 conf+=" -I${S}/include"
462 # Add hint for the framework location.
463 conf+=" -F${QTLIBDIR}"
317 464
318 # We are crazy and build cocoa + qt3support :-) 465 # We are crazy and build cocoa + qt3support :-)
319 if use qt3support; then 466 if use qt3support; then
320 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 467 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
321 -i configure 468 -i configure || die
322 fi 469 fi
323 470 else
324 # We need the source's headers, not the installed ones. 471 conf+=" -no-framework"
325 myconf+=" -I${S}/include"
326
327 # Add hint for the framework location.
328 myconf+=" -F${QTLIBDIR}"
329 fi 472 fi
330 else 473 else
331 # freetype2 include dir is non-standard, thus include it on configure 474 # freetype2 include dir is non-standard, thus pass it to configure
332 # use -I from configure
333 myconf+=" $(pkg-config --cflags freetype2)" 475 conf+=" $(pkg-config --cflags-only-I freetype2)"
334 fi 476 fi
335 477
336 # Disable SSE4.x, since auto-detection is currently broken 478 conf+=" ${myconf}"
337 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 479 myconf=
338 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
339 480
340 echo ./configure ${myconf} 481 echo ./configure ${conf}
341 ./configure ${myconf} || die "./configure failed" 482 ./configure ${conf} || die "./configure failed"
342 myconf=""
343 483
344 prepare_directories ${QT4_TARGET_DIRECTORIES} 484 prepare_directories ${QT4_TARGET_DIRECTORIES}
345} 485}
346 486
347# @FUNCTION: qt4-build_src_compile 487# @FUNCTION: qt4-build_src_compile
488# @DESCRIPTION:
348# @DESCRIPTION: Actual compile phase 489# Actual compile phase
349qt4-build_src_compile() { 490qt4-build_src_compile() {
350 setqtenv 491 setqtenv
351 492
352 build_directories ${QT4_TARGET_DIRECTORIES} 493 build_directories ${QT4_TARGET_DIRECTORIES}
353} 494}
354 495
355# @FUNCTION: qt4-build_src_test 496# @FUNCTION: qt4-build_src_test
356# @DESCRIPTION: 497# @DESCRIPTION:
357# Runs tests only in target directories. 498# Runs tests only in target directories.
358qt4-build_src_test() { 499qt4-build_src_test() {
500 # QtMultimedia does not have any test suite (bug #332299)
501 [[ ${PN} == qt-multimedia ]] && return
502
359 for dir in ${QT4_TARGET_DIRECTORIES}; do 503 for dir in ${QT4_TARGET_DIRECTORIES}; do
360 emake -j1 check -C ${dir} 504 emake -j1 check -C ${dir}
361 done 505 done
362} 506}
363 507
364# @FUNCTION: fix_includes 508# @FUNCTION: fix_includes
365# @DESCRIPTION: 509# @DESCRIPTION:
366# For MacOSX we need to add some symlinks when frameworks are 510# For MacOS X we need to add some symlinks when frameworks are
367# being used, to avoid complications with some more or less stupid packages. 511# being used, to avoid complications with some more or less stupid packages.
368fix_includes() { 512fix_includes() {
369 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 513 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
514 local frw dest f h rdir
370 # Some packages tend to include <Qt/...> 515 # Some packages tend to include <Qt/...>
371 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 516 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
372 517
373 # Fake normal headers when frameworks are installed... eases life later on 518 # Fake normal headers when frameworks are installed... eases life later
374 local dest f 519 # on, make sure we use relative links though, as some ebuilds assume
520 # these dirs exist in src_install to add additional files
521 f=${QTHEADERDIR}
522 h=${QTLIBDIR}
523 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
524 f=${f#*/}
525 h=${h#*/}
526 done
527 rdir=${h}
528 f="../"
529 while [[ ${h} == */* ]] ; do
530 f="${f}../"
531 h=${h#*/}
532 done
533 rdir="${f}${rdir}"
534
375 for frw in "${D}${QTLIBDIR}"/*.framework; do 535 for frw in "${D}${QTLIBDIR}"/*.framework; do
376 [[ -e "${frw}"/Headers ]] || continue 536 [[ -e "${frw}"/Headers ]] || continue
377 f=$(basename ${frw}) 537 f=$(basename ${frw})
378 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 538 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
379 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 539 dosym "${rdir}"/${f}/Headers "${dest}"
380 540
381 # Link normal headers as well. 541 # Link normal headers as well.
382 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 542 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
383 h=$(basename ${hdr}) 543 h=$(basename ${hdr})
384 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 544 dosym "../${rdir}"/${f}/Headers/${h} \
545 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
385 done 546 done
386 done 547 done
387 fi 548 fi
388} 549}
389 550
391# @DESCRIPTION: 552# @DESCRIPTION:
392# Perform the actual installation including some library fixes. 553# Perform the actual installation including some library fixes.
393qt4-build_src_install() { 554qt4-build_src_install() {
394 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 555 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
395 setqtenv 556 setqtenv
557
396 install_directories ${QT4_TARGET_DIRECTORIES} 558 install_directories ${QT4_TARGET_DIRECTORIES}
397 install_qconfigs 559 install_qconfigs
398 fix_library_files 560 fix_library_files
399 fix_includes 561 fix_includes
562
400 # remove .la files since we are building only shared Qt libraries 563 # remove .la files since we are building only shared Qt libraries
401 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 564 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
402} 565}
403 566
404# @FUNCTION: setqtenv 567# @FUNCTION: setqtenv
568# @INTERNAL
405setqtenv() { 569setqtenv() {
406 # Set up installation directories 570 # Set up installation directories
407 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
408 QTPREFIXDIR=${EPREFIX}/usr 571 QTPREFIXDIR=${EPREFIX}/usr
409 QTBINDIR=${EPREFIX}/usr/bin 572 QTBINDIR=${EPREFIX}/usr/bin
410 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 573 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
411 QMAKE_LIBDIR_QT=${QTLIBDIR}
412 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 574 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
413 QTDATADIR=${EPREFIX}/usr/share/qt4
414 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 575 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
415 QTHEADERDIR=${EPREFIX}/usr/include/qt4 576 QTHEADERDIR=${EPREFIX}/usr/include/qt4
416 QTPLUGINDIR=${QTLIBDIR}/plugins 577 QTPLUGINDIR=${QTLIBDIR}/plugins
578 QTIMPORTDIR=${QTLIBDIR}/imports
579 QTDATADIR=${EPREFIX}/usr/share/qt4
580 QTTRANSDIR=${QTDATADIR}/translations
417 QTSYSCONFDIR=${EPREFIX}/etc/qt4 581 QTSYSCONFDIR=${EPREFIX}/etc/qt4
418 QTTRANSDIR=${QTDATADIR}/translations
419 QTEXAMPLESDIR=${QTDATADIR}/examples 582 QTEXAMPLESDIR=${QTDATADIR}/examples
420 QTDEMOSDIR=${QTDATADIR}/demos 583 QTDEMOSDIR=${QTDATADIR}/demos
584 QMAKE_LIBDIR_QT=${QTLIBDIR}
421 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 585 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
586
422 PLATFORM=$(qt_mkspecs_dir) 587 PLATFORM=$(qt_mkspecs_dir)
423
424 unset QMAKESPEC 588 unset QMAKESPEC
425}
426 589
427# @FUNCTION: standard_configure_options 590 export XDG_CONFIG_HOME="${T}"
428# @DESCRIPTION:
429# Sets up some standard configure options, like libdir (if necessary), whether
430# debug info is wanted or not.
431standard_configure_options() {
432 local myconf=
433
434 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
435
436 # Disable visibility explicitly if gcc version isn't 4
437 if [[ $(gcc-major-version) -lt 4 ]]; then
438 myconf+=" -no-reduce-exports"
439 fi
440
441 # precompiled headers doesn't work on hardened, where the flag is masked.
442 myconf+=" $(qt_use pch)"
443
444 if use debug; then
445 myconf+=" -debug"
446 else
447 myconf+=" -release"
448 fi
449 myconf+=" -no-separate-debug-info"
450
451 use aqua && myconf+=" -no-framework"
452
453 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
454 # $(tc-arch). Therefore we convert it to supported values.
455 case "$(tc-arch)" in
456 amd64|x64-*) myconf+=" -arch x86_64" ;;
457 ppc-macos) myconf+=" -arch ppc" ;;
458 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
459 sparc|sparc-*) myconf+=" -arch sparc" ;;
460 x86-macos) myconf+=" -arch x86" ;;
461 x86|x86-*) myconf+=" -arch i386" ;;
462 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
463 hppa|sh) myconf+=" -arch generic" ;;
464 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
465 esac
466
467 # 4.5: build everything but qt-xmlpatterns w/o exceptions
468 # 4.6: exceptions USE flag
469 local exceptions="-exceptions"
470 case "${PV}" in
471 4.5.*)
472 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
473 ;;
474 *)
475 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
476 ;;
477 esac
478
479 # note about -reduce-relocations:
480 # That flag seems to introduce major breakage to applications,
481 # mostly to be seen as a core dump with the message "QPixmap: Must
482 # construct a QApplication before a QPaintDevice" on Solaris
483 # -- Daniel Vergien
484 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
485
486 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
487 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
488 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
489 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
490 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
491 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
492 ${exceptions}
493 -nomake examples -nomake demos"
494
495 echo "${myconf}"
496} 591}
497 592
498# @FUNCTION: prepare_directories 593# @FUNCTION: prepare_directories
499# @USAGE: < directories > 594# @USAGE: < directories >
595# @INTERNAL
500# @DESCRIPTION: 596# @DESCRIPTION:
501# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 597# Generates Makefiles for the given list of directories.
502prepare_directories() { 598prepare_directories() {
503 for x in "$@"; do 599 for x in "$@"; do
504 pushd "${S}"/${x} >/dev/null 600 pushd "${S}"/${x} >/dev/null || die
505 einfo "running qmake in: $x" 601 einfo "Running qmake in: ${x}"
506 # avoid running over the maximum argument number, bug #299810 602 # avoid running over the maximum argument number, bug #299810
507 { 603 {
508 echo "${S}"/mkspecs/common/*.conf 604 echo "${S}"/mkspecs/common/*.conf
509 find "${S}" -name '*.pr[io]' 605 find "${S}" -name '*.pr[io]'
510 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 606 } | xargs sed -i \
607 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
608 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
609 || die
511 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 610 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
512 popd >/dev/null 611 popd >/dev/null || die
513 done 612 done
514} 613}
515 614
516 615
517# @FUNCTION: build_directories 616# @FUNCTION: build_directories
518# @USAGE: < directories > 617# @USAGE: < directories >
618# @INTERNAL
519# @DESCRIPTION: 619# @DESCRIPTION:
520# Compiles the code in $QT4_TARGET_DIRECTORIES 620# Compiles the code in the given list of directories.
521build_directories() { 621build_directories() {
522 for x in "$@"; do 622 for x in "$@"; do
523 pushd "${S}"/${x} >/dev/null 623 pushd "${S}"/${x} >/dev/null || die
524 emake CC="$(tc-getCC)" \ 624 emake CC="$(tc-getCC)" \
525 CXX="$(tc-getCXX)" \ 625 CXX="$(tc-getCXX)" \
526 LINK="$(tc-getCXX)" || die "emake failed" 626 LINK="$(tc-getCXX)" || die "emake failed"
527 popd >/dev/null 627 popd >/dev/null || die
528 done 628 done
529} 629}
530 630
531# @FUNCTION: install_directories 631# @FUNCTION: install_directories
532# @USAGE: < directories > 632# @USAGE: < directories >
633# @INTERNAL
533# @DESCRIPTION: 634# @DESCRIPTION:
534# run emake install in the given directories, which are separated by spaces 635# Runs emake install in the given directories, which are separated by spaces.
535install_directories() { 636install_directories() {
536 for x in "$@"; do 637 for x in "$@"; do
537 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 638 pushd "${S}"/${x} >/dev/null || die
538 emake INSTALL_ROOT="${D}" install || die "emake install failed" 639 emake INSTALL_ROOT="${D}" install || die "emake install failed"
539 popd >/dev/null || die "Can't popd from ${S}/${x}" 640 popd >/dev/null || die
540 done 641 done
541} 642}
542 643
543# @ECLASS-VARIABLE: QCONFIG_ADD 644# @ECLASS-VARIABLE: QCONFIG_ADD
544# @DESCRIPTION: 645# @DESCRIPTION:
554# @DESCRIPTION: 655# @DESCRIPTION:
555# List variables that should be defined at the top of QtCore/qconfig.h 656# List variables that should be defined at the top of QtCore/qconfig.h
556: ${QCONFIG_DEFINE:=} 657: ${QCONFIG_DEFINE:=}
557 658
558# @FUNCTION: install_qconfigs 659# @FUNCTION: install_qconfigs
660# @INTERNAL
661# @DESCRIPTION:
559# @DESCRIPTION: Install gentoo-specific mkspecs configurations 662# Install gentoo-specific mkspecs configurations.
560install_qconfigs() { 663install_qconfigs() {
561 local x 664 local x
562 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 665 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
563 for x in QCONFIG_ADD QCONFIG_REMOVE; do 666 for x in QCONFIG_ADD QCONFIG_REMOVE; do
564 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 667 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
575 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 678 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
576 fi 679 fi
577} 680}
578 681
579# @FUNCTION: generate_qconfigs 682# @FUNCTION: generate_qconfigs
580# @DESCRIPTION: Generates gentoo-specific configurations 683# @INTERNAL
684# @DESCRIPTION:
685# Generates gentoo-specific qconfig.{h,pri}.
581generate_qconfigs() { 686generate_qconfigs() {
582 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 687 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
583 local x qconfig_add qconfig_remove qconfig_new 688 local x qconfig_add qconfig_remove qconfig_new
584 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 689 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
585 [[ -f ${x} ]] || continue 690 [[ -f ${x} ]] || continue
586 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 691 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
587 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 692 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
633 fi 738 fi
634 fi 739 fi
635} 740}
636 741
637# @FUNCTION: qt4-build_pkg_postrm 742# @FUNCTION: qt4-build_pkg_postrm
743# @DESCRIPTION:
638# @DESCRIPTION: Generate configurations when the package is completely removed 744# Regenerate configuration when the package is completely removed.
639qt4-build_pkg_postrm() { 745qt4-build_pkg_postrm() {
640 generate_qconfigs 746 generate_qconfigs
641} 747}
642 748
643# @FUNCTION: qt4-build_pkg_postinst 749# @FUNCTION: qt4-build_pkg_postinst
750# @DESCRIPTION:
644# @DESCRIPTION: Generate configuration, plus throws a message about possible 751# Regenerate configuration, plus throw a message about possible
645# breakages and proposed solutions. 752# breakages and proposed solutions.
646qt4-build_pkg_postinst() { 753qt4-build_pkg_postinst() {
647 generate_qconfigs 754 generate_qconfigs
648} 755}
649 756
650# @FUNCTION: skip_qmake_build_patch 757# @FUNCTION: skip_qmake_build
758# @INTERNAL
651# @DESCRIPTION: 759# @DESCRIPTION:
652# Don't need to build qmake, as it's already installed from qt-core 760# Patches configure to skip qmake compilation, as it's already installed by qt-core.
653skip_qmake_build_patch() { 761skip_qmake_build() {
654 # Don't need to build qmake, as it's already installed from qt-core
655 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 762 sed -i -e "s:if true:if false:g" "${S}"/configure || die
656} 763}
657 764
658# @FUNCTION: skip_project_generation_patch 765# @FUNCTION: skip_project_generation
766# @INTERNAL
659# @DESCRIPTION: 767# @DESCRIPTION:
660# Exit the script early by throwing in an exit before all of the .pro files are scanned 768# Exit the script early by throwing in an exit before all of the .pro files are scanned.
661skip_project_generation_patch() { 769skip_project_generation() {
662 # Exit the script early by throwing in an exit before all of the .pro files are scanned
663 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 770 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
664 -i "${S}"/configure || die "Sed failed"
665} 771}
666 772
667# @FUNCTION: symlink_binaries_to_buildtree 773# @FUNCTION: symlink_binaries_to_buildtree
774# @INTERNAL
668# @DESCRIPTION: 775# @DESCRIPTION:
669# Symlink generated binaries to buildtree so they can be used during compilation 776# Symlinks generated binaries to buildtree, so they can be used during compilation time.
670# time
671symlink_binaries_to_buildtree() { 777symlink_binaries_to_buildtree() {
672 for bin in qmake moc uic rcc; do 778 for bin in qmake moc uic rcc; do
673 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 779 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
674 done 780 done
675} 781}
676 782
677# @FUNCTION: fix_library_files 783# @FUNCTION: fix_library_files
784# @INTERNAL
678# @DESCRIPTION: 785# @DESCRIPTION:
679# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 786# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
680# moves the *.pc-files into the pkgconfig directory 787# moves the *.pc files into the pkgconfig directory.
681fix_library_files() { 788fix_library_files() {
789 local libfile
682 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 790 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
683 if [[ -e ${libfile} ]]; then 791 if [[ -e ${libfile} ]]; then
684 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 792 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
685 fi 793 fi
686 done 794 done
687 795
688 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 796 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
689 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 797 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
690 if [[ -e ${libfile} ]]; then 798 if [[ -e ${libfile} ]]; then
691 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 799 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
692 800
693 # Move .pc files into the pkgconfig directory 801 # Move .pc files into the pkgconfig directory
694 dodir ${QTPCDIR#${EPREFIX}} 802 dodir ${QTPCDIR#${EPREFIX}}
695 mv ${libfile} "${D}"/${QTPCDIR}/ \ 803 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
696 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
697 fi 804 fi
698 done 805 done
699 806
700 # Don't install an empty directory 807 # Don't install an empty directory
701 rmdir "${D}"/${QTLIBDIR}/pkgconfig 808 rmdir "${D}"/${QTLIBDIR}/pkgconfig
702} 809}
703 810
704# @FUNCTION: qt_use 811# @FUNCTION: qt_use
705# @USAGE: < flag > [ feature ] [ enableval ] 812# @USAGE: < flag > [ feature ] [ enableval ]
706# @DESCRIPTION: 813# @DESCRIPTION:
707# This will echo "${enableval}-${feature}" if <flag> is enabled, or 814# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
708# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 815# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
709# will be used for that. If [enableval] is not specified, it omits the 816# will be used for that. If [enableval] is not specified, it omits the
710# assignment-part 817# "-${enableval}" part.
711qt_use() { 818qt_use() {
712 local flag=$1 819 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
713 local feature=$1
714 local enableval=
715
716 [[ -n $2 ]] && feature=$2
717 [[ -n $3 ]] && enableval=-$3
718
719 if use ${flag}; then
720 echo "${enableval}-${feature}"
721 else
722 echo "-no-${feature}"
723 fi
724} 820}
725 821
726# @FUNCTION: qt_mkspecs_dir 822# @FUNCTION: qt_mkspecs_dir
727# @RETURN: the specs-directory w/o path 823# @RETURN: the specs-directory w/o path
728# @DESCRIPTION: 824# @DESCRIPTION:
729# Allows us to define which mkspecs dir we want to use. 825# Allows us to define which mkspecs dir we want to use.
730qt_mkspecs_dir() { 826qt_mkspecs_dir() {
731 # Allows us to define which mkspecs dir we want to use.
732 local spec 827 local spec=
733 828
734 case ${CHOST} in 829 case "${CHOST}" in
735 *-freebsd*|*-dragonfly*) 830 *-freebsd*|*-dragonfly*)
736 spec=freebsd ;; 831 spec=freebsd ;;
737 *-openbsd*) 832 *-openbsd*)
738 spec=openbsd ;; 833 spec=openbsd ;;
739 *-netbsd*) 834 *-netbsd*)
750 *-solaris*) 845 *-solaris*)
751 spec=solaris ;; 846 spec=solaris ;;
752 *-linux-*|*-linux) 847 *-linux-*|*-linux)
753 spec=linux ;; 848 spec=linux ;;
754 *) 849 *)
755 die "Unknown CHOST, no platform choosen." 850 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
756 esac 851 esac
757 852
758 CXX=$(tc-getCXX) 853 case "$(tc-getCXX)" in
759 if [[ ${CXX} == *g++* ]]; then 854 *g++*)
760 spec+=-g++ 855 spec+=-g++ ;;
761 elif [[ ${CXX} == *icpc* ]]; then 856 *icpc*)
762 spec+=-icc 857 spec+=-icc ;;
763 else 858 *)
764 die "Unknown compiler ${CXX}." 859 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
765 fi 860 esac
766 if [[ -n ${LIBDIR/lib} ]]; then
767 spec+=-${LIBDIR/lib}
768 fi
769 861
770 # Add -64 for 64bit profiles 862 # Add -64 for 64bit profiles
771 if use x64-freebsd || 863 if use x64-freebsd ||
772 use amd64-linux || 864 use amd64-linux ||
773 use x64-macos || 865 use x64-macos ||
779 871
780 echo "${spec}" 872 echo "${spec}"
781} 873}
782 874
783# @FUNCTION: qt_assistant_cleanup 875# @FUNCTION: qt_assistant_cleanup
784# @RETURN: nothing 876# @INTERNAL
785# @DESCRIPTION: 877# @DESCRIPTION:
786# Tries to clean up tools.pro for qt-assistant ebuilds 878# Tries to clean up tools.pro for qt-assistant ebuilds.
787# Meant to be called in src_prepare 879# Meant to be called in src_prepare().
880# Since Qt 4.7.4 this function is a no-op.
788qt_assistant_cleanup() { 881qt_assistant_cleanup() {
882 # apply patching to qt-assistant ebuilds only
883 [[ ${PN} != qt-assistant ]] && return
884
885 # no longer needed for 4.7.4 and later
886 version_is_at_least 4.7.4 && return
887
789 # different versions (and branches...) may need different handling, 888 # different versions (and branches...) may need different handling,
790 # add a case if you need special handling 889 # add a case if you need special handling
791 case "${MY_PV_EXTRA}" in 890 case "${MY_PV_EXTRA}" in
792 *kde-qt*) 891 *kde-qt*)
793 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \ 892 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
802 ;; 901 ;;
803 esac 902 esac
804} 903}
805 904
806# @FUNCTION: qt_nolibx11 905# @FUNCTION: qt_nolibx11
807# @RETURN: nothing 906# @INTERNAL
808# @DESCRIPTION: 907# @DESCRIPTION:
809# Ignore X11 tests for packages that don't need X libraries installed 908# Ignore X11 tests for packages that don't need X libraries installed.
810qt_nolibx11() { 909qt_nolibx11() {
811 einfo "removing X11 check to allow X-less compilation"
812 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 910 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
813 die "x11 check sed failed" 911 die "x11 check sed failed"
814} 912}
815 913
816EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 914EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.91  
changed lines
  Added in v.1.132

  ViewVC Help
Powered by ViewVC 1.1.20